package cfdicompleto;

import https.cfd_sicofi_com.ArrayOfAnyType;
import https.cfd_sicofi_com.Concepto;
import https.cfd_sicofi_com.DatosCFD;
import https.cfd_sicofi_com.Impuesto;
import https.cfd_sicofi_com.Receptor;

public class CFDICompleto {
        String usuario = "demo1@sicofi.com.mx";
        String password = "demodemoD";
        

    public static void main(String[] args) {
        CFDICompleto Proceso = new CFDICompleto();
        Proceso.GeneraCFDI();//Genera el CFDI que deseamos
        Proceso.GeneraPDF();//Nos regresa el arreglo de Bytes para formar un pdf
        Proceso.StatusCFDI();//modifica el status del cfdi
        Proceso.CancelaCFDI();
        Proceso.AcuseCFDI();

    }
    public String GeneraCFDI() {
        String xml = "";
        try {
            https.cfd_sicofi_com.DatosCFD datosCFD = new DatosCFD(); // Inicializamos DatosCFD

            datosCFD.setSerie("A");
            datosCFD.setFormadePago("Pago en una sola exhibicion");
            datosCFD.setTipodeComprobante("F");
            datosCFD.setMetododePago("Tarjeta de Credito");
            datosCFD.setEmailMensaje("Mensaje Extra");
            datosCFD.setSubtotal(100);
            datosCFD.setTotal(116);
            datosCFD.setLugarDeExpedicion("Mexico DF");

            https.cfd_sicofi_com.Receptor receptor = new Receptor();

            receptor.setCalle("Viveros");
            receptor.setNumExt("10");
            receptor.setNumInt("B");
            receptor.setColonia("Viveros de la Loma");
            receptor.setContacto1("Radoslaw Wolak");
            receptor.setContacto2("Juan Manuel Lozano");
            receptor.setCP("54080");
            receptor.setMunicipio("Tlalnepantla");
            receptor.setNoCliente("AAA01");
            receptor.setTelefono1("5546212345");
            receptor.setTelefono2("5546123456");
            receptor.setCiudad("Mexico");
            receptor.setEstado("Edo. de Mex.");
            receptor.setPais("Mexico");
            receptor.setEmail1("emailprueba@mail.com.mx");
            receptor.setEmail2("emailprueba@mail.com.mx");
            receptor.setEmail3("emailprueba@mail.com.mx");
            receptor.setRFC("WOPR8002248Z6");
            receptor.setRazonSocial("Razon Social De Prueba");

            ArrayOfAnyType conceptos = new ArrayOfAnyType();//Inicializamos el arreglo de Conceptos 

            https.cfd_sicofi_com.Concepto conceptoWS = new Concepto();
            conceptoWS.setCantidad(10);
            conceptoWS.setUnidad("pza.");
            conceptoWS.setDescripcion("Lapiceros");
            conceptoWS.setPrecio(24.99);
            conceptoWS.setImporte(125);
            conceptos.getAnyType().add(conceptoWS);

            conceptoWS = new Concepto();

            conceptoWS.setCantidad(10);
            conceptoWS.setUnidad("pza.");
            conceptoWS.setDescripcion("Plumas");
            conceptoWS.setPrecio(125.49);
            conceptoWS.setImporte(1250.90);
            conceptos.getAnyType().add(conceptoWS);

            https.cfd_sicofi_com.ArrayOfAnyType impuestos = new ArrayOfAnyType();//Inicializamos el arreglo de Impuestos 
            https.cfd_sicofi_com.Impuesto impuestoWS = new Impuesto();

            impuestoWS.setTasa(16);
            impuestoWS.setTipoImpuesto("IVA");
            impuestoWS.setImporte(220.77);
            impuestos.getAnyType().add(impuestoWS);
            impuestoWS = new Impuesto();
            impuestoWS.setTasa(8);
            impuestoWS.setTipoImpuesto("IVAR");
            impuestoWS.setImporte(110.39);
            String xmladdenda = "";
            
            https.cfd_sicofi_com.CFD service = new https.cfd_sicofi_com.CFD();
            https.cfd_sicofi_com.CFDSoap port = service.getCFDSoap();
            xml = port.generaCFD("demo1@sicofi.com.mx", "demodemo", datosCFD, receptor, conceptos, impuestos, xmladdenda);
            
        } catch (Exception e) {
            System.out.print(e);
        }
        return xml;
    }
    public byte[] GeneraPDF() {
        byte[] pdf = null;
        int folio = 2;
        String serie = "A";
        try {
            https.cfd_sicofi_com.CFD service = new https.cfd_sicofi_com.CFD();
            https.cfd_sicofi_com.CFDSoap port = service.getCFDSoap();
            pdf = port.generaPDF(usuario, password, serie, folio);
        } catch (Exception e) {
            System.out.print(e);
        }
        return pdf;
    }
    public String StatusCFDI()
    {
        int folio = 10;
        String serie = "A";
       
        String Respuesta = "";
//         -3 Cancela CFDI
//         -2 Cancela CFD
//         -1 No liberado
//          0 no pagado 
//          1 pagado
        try {
            https.cfd_sicofi_com.CFD service = new https.cfd_sicofi_com.CFD();
            https.cfd_sicofi_com.CFDSoap port = service.getCFDSoap();
            Respuesta = port.cambiaStatusFact(usuario, password, serie, folio, -3);
        } catch (Exception e) {
            System.out.print(e);
        }
        return Respuesta;
    }
    public String CancelaCFDI()
    {
        String uuid = "50061ADB-C877-4FF6-BA08-190F12181845";
        String Respuesta = "";

        try {
            https.cfd_sicofi_com.CFD service = new https.cfd_sicofi_com.CFD();
            https.cfd_sicofi_com.CFDSoap port = service.getCFDSoap();
            Respuesta = port.cancelaCFDI(usuario, password, uuid);
        } catch (Exception e) {
            System.out.print(e);
        }
        return Respuesta;
    }
    public String AcuseCFDI()
    {
        String uuid = "DD70EE7E-1315-42E7-AAB0-9AFD53C3165E";//Este uuid es de muestra para Demo, De preferencia no cambiarlo.
        String Respuesta = "";
        try {
            https.cfd_sicofi_com.CFD service = new https.cfd_sicofi_com.CFD();
            https.cfd_sicofi_com.CFDSoap port = service.getCFDSoap();
            Respuesta = port.acuseCancelacion(usuario, password, uuid);
            System.out.println(Respuesta);
        } catch (Exception e) {
            System.out.print(e);
        }
        return Respuesta;
    }

}
